module top (
    input clk,
    input nreset,

    output [7:0] gpio_out,
    input [7:0] gpio_in,

    input int0,
    input int1,
    input int2,
    input int3,
    input int4,

    output timer_out,

    // output [7:0] debug,
    // output sclk,

    input prog_din,
	input prog_clk,
	input prog_latch,

    output tx_pin,
    input rx_pin
);
    wire reset = !nreset;
    wire sclk;
    // assign sclk = clk;
    wire coreclk;

    wire [7:0] data_bus;
    wire [15:0] address_bus;

    wire mem_write;
    wire mem_read;

    wire io_out;
    wire io_in;

    wire uart_int;
    
	phoenixClockDivider div (clk, sclk);

    phoenix soc (
        sclk,
        reset,
        data_bus,
        address_bus,
        mem_write,
        mem_read,
        io_out,
        io_in,
        gpio_out,
        gpio_in,
        int0,
        int1,
        int2,
        int3,
        int4,
        uart_int,
        timer_out
    );

    phoenixRam ram (
        clk,
        mem_read,
        mem_write,
        data_bus,
        address_bus,
        prog_din,
        prog_clk,
        prog_latch
    );

    phoenixUart uart (
        .clk(sclk),
        .reset(reset),
        .io_in(io_in),
        .io_out(io_out),
        .address_bus(address_bus),
        .data_bus(data_bus),
        .tx_pin(tx_pin),
        .rx_pin(rx_pin),
        .uart_int(uart_int),
        .uart_clk(clk)
    );

    // assign debug = {prog_din,prog_latch,prog_clk};

endmodule

