module phoenixClockDividerBy2 (
    input wire clk,
    output reg out
);
    reg toggle = 1'b0;

    always @(posedge clk) begin
        toggle <= ~toggle;
        out <= toggle;
    end
endmodule

module phoenixClockDivider (
    input wire clk,
    output reg out 
);
    reg [31:0] counter;

    parameter divider = 16;

    always @(posedge clk) begin
        if (counter == divider) begin
            counter <= 0;
            out <= ~out;
        end
        else begin
            counter <= counter + 1;
        end
    end

endmodule