module phoenixMicrocode (
    input clk,
    input mask,
    output PUT_A_ADDR,
    output PUT_IR0_DB,
    output PUT_IR1_DB,
    
    output SAVE_DB_IR0,
    output SAVE_DB_IR1,
    
    output PUT_IIMM_DB,

    output SAVE_DB_ALUA,
    output SAVE_DB_ALUB,

    output ALU_ADD,
    output ALU_CMP,

    output PUT_ALUOUT_DB,

    output COND_INVERT,

    output SAVE_PCB_IF_Z,
    output SAVE_PCB_IF_EQ,
    output SAVE_PCB,

    output SAVE_DB_MEM,
    output PUT_MEM_DB,

    output PC_FLUSH,
    output PC_FLUSH_COND,

    output ALU_SUB,
    output ALU_NAND,
    output ALU_NOR,

    output IO_IN,
    output IO_OUT,

    output PUT_B_ADDR,
    output PUT_IADDR_ADDR,

    output SAVE_ADDR_A,
    output SAVE_ADDR_B,

    output INT_RET_TO_ADDR,
    output SOFTWARE_INTERRUPT,

    output FINISH,

    output SAVE_PCB_IF_OF,

    output CLEAR_FG,

    output ALU_ADO,
    output ALU_SBO,

    output SAVE_IH,

    output PUT_FG_DB,
    output PUT_DB_FG,

    output SP_UP,
    output SP_DOWN,

    output SAVE_ADDR_SP,
    output PUT_SP_ADDR,

    input [7:0] instruction,
    input [2:0] step
);

    reg [31:0] mc_p_1 [0:1785];
    reg [31:0] mc_p_2 [0:1785];

    reg [10:0] index;

    wire [31:0] m0 = mc_p_1[index];
    wire [31:0] m1 = mc_p_2[index];

    always @(posedge clk) begin
        index <= {instruction, step};
    end


    assign PUT_A_ADDR = m0[0] & mask;
    assign PUT_IR0_DB = m0[1] & mask;
    assign PUT_IR1_DB = m0[2] & mask;
    assign SAVE_DB_IR0 = m0[3] & mask;
    assign SAVE_DB_IR1 = m0[4] & mask;
    assign PUT_IIMM_DB = m0[5] & mask;
    assign SAVE_DB_ALUA = m0[6] & mask;
    assign SAVE_DB_ALUB = m0[7] & mask;
    assign ALU_ADD = m0[8] & mask;
    assign ALU_CMP = m0[9] & mask;
    assign PUT_ALUOUT_DB = m0[10] & mask;
    assign COND_INVERT = m0[11] & mask;
    assign SAVE_PCB_IF_Z = m0[12] & mask;
    assign SAVE_PCB_IF_EQ = m0[13] & mask;
    assign SAVE_PCB = m0[14] & mask;
    assign SAVE_DB_MEM = m0[15] & mask;
    assign PUT_MEM_DB = m0[16] & mask;
    assign PC_FLUSH = m0[17] & mask;
    assign PC_FLUSH_COND = m0[18] & mask;
    assign ALU_SUB = m0[19] & mask;
    assign ALU_NAND = m0[20] & mask;
    assign ALU_NOR = m0[21] & mask;
    assign IO_IN = m0[22] & mask;
    assign IO_OUT = m0[23] & mask;
    assign PUT_B_ADDR = m0[24] & mask;
    assign PUT_IADDR_ADDR = m0[25] & mask;
    assign SAVE_ADDR_A = m0[26] & mask;
    assign SAVE_ADDR_B = m0[27] & mask;
    assign INT_RET_TO_ADDR = m0[28] & mask;
    assign SOFTWARE_INTERRUPT = m0[29] & mask;
    assign FINISH = m0[31] & mask;

    assign SAVE_PCB_IF_OF = m1[0] & mask;
    assign CLEAR_FG = m1[1] & mask;
    assign ALU_ADO = m1[2] & mask;
    assign ALU_SBO = m1[3] & mask;
    assign SAVE_IH = m1[4] & mask;
    assign PUT_FG_DB = m1[5] & mask;
    assign PUT_DB_FG = m1[6] & mask;
    assign SP_UP = m1[7] & mask;
    assign SP_DOWN = m1[8] & mask;
    assign SAVE_ADDR_SP = m1[9] & mask;
    assign PUT_SP_ADDR = m1[10] & mask;

    initial begin
        $readmemh("mc_p_1.hex", mc_p_1);
        $readmemh("mc_p_2.hex", mc_p_2);
    end
endmodule