module phoenixStackRegister (
    input clk,

    input SP_UP,
    input SP_DOWN,

    input SAVE_ADDR_SP,
    input PUT_SP_ADDR,

    inout [15:0] address_bus
);
    reg [15:0] sp;

    assign address_bus = PUT_SP_ADDR ? sp : 16'bzzzzzzzzzzzzzzzz;

    always @(negedge clk) begin
        if (SP_DOWN) begin
            sp <= sp - 1;
        end
        if (SP_UP) begin
            sp <= sp + 1;
        end
        if (SAVE_ADDR_SP) begin
            sp <= address_bus;
        end
    end
endmodule