module phoenixInterruptController (
    input clk,
    input reset,

    input interrupt_done,

    input io_in,
    input io_out,

    input [15:0] address_bus,
    inout [7:0] data_bus,

    input [7:0] interrupt_in,

    output trigger
);

    reg [7:0] port_in;
    wire [7:0] port_out;

    
    phoenixIo in (
        .clk(clk),
        .reset(reset),
        .io_in(io_in),
        .io_out(io_out),
        .address_bus(address_bus),
        .data_bus(data_bus),
        .port_in(port_in),
        .port_out(port_out),
        .clear(1'b0)
    );
    defparam in.address = 16'hff00;

    assign trigger = port_in != 8'b00000000;


    always @(posedge clk or posedge reset or posedge interrupt_done) begin
        if (reset || interrupt_done) begin
            port_in <= 8'd0;
        end else begin
            port_in <= (port_in | interrupt_in) & port_out;
        end
    end
endmodule