module phoenixIo (
    input clk,
    input reset,

    input io_in,
    input io_out,

    input [15:0] address_bus,
    inout [7:0] data_bus,

    input [7:0] port_in,
    output reg [7:0] port_out,

    input clear    
);
    parameter address = 16'b0;

    assign data_bus = (io_in && (address_bus == address)) ? port_in : 8'bzzzzzzzz;

    always @(negedge clk or posedge reset or posedge clear) begin
        if (reset | clear) begin
            port_out <= 8'd0;
        end else begin
            if (io_out && (address_bus == address)) begin
                port_out <= data_bus;
            end
        end
    end

endmodule