// This ram should be async (since the cpu expects async ram) but my fpga only supports sync ram... a hacky workaround is to just run the ram at 2x (or at least i thought 2x... on my fpga it needs to be more?? idk core has divider 16 now) soc clock speed

module phoenixRam (
	input clk,

	input read,
	input write,

	inout [7:0] data_bus,
	input [15:0] address_bus,

	input prog_din,
	input prog_clk,
	input prog_latch
);
	reg [7:0] memory [0:(64 * 1024) - 1];

    reg [7:0] out;
    assign data_bus = out;

	wire [23:0] prog_data;
	reg24_shift prog (
		.clk(prog_clk),
		.din(prog_din),
		.data(prog_data)
	);

	wire [15:0] prog_adr = prog_data[23:8];
	wire [7:0] prog_byte = prog_data[7:0];

    always @(posedge clk) begin
        if (read) begin 
            out <= memory[address_bus];			
        end else begin
            out <= 8'bzzzzzzzz;
        end
    end

	always @(negedge clk) begin
		if (write) begin
			memory[address_bus] <= data_bus;
		end else if (prog_latch) begin
			memory[prog_adr] <= prog_byte;
		end
	end

	initial begin
`ifdef FIRMWARE
		$readmemh(`FIRMWARE, memory);
`else
        $readmemh("firmware.hex", memory);
`endif
    end
endmodule
